#include "../stdafx.h"
#include "StandardOutput.h"
#include "audio.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

Out_Module standardOut =
{
	0,  					// module version (OUT_VER)
	outDescription, 		// description of module, with version string
	0,  					// module id. each input module gets its own. non-nullsoft modules should be >= 65536. 
	0,  					// winamp's main window (filled in by winamp)
	0,  					// DLL instance handle (filled in by winamp)
	OutputConfig,   		// configuration dialog 
	OutputAbout,			// about dialog
	OutputInit, 			// called when loaded
	OutputQuit, 			// called when unloaded
	OutputOpen, 			//
	OutputClose,			// close the ol' output device.
	OutputPlay, 		   //
	CanWrite,   			// returns number of bytes possible to write at a given time. Never will decrease unless you call Write (or Close, heh)
	IsPlaying,  			// non0 if output is still going or if data in buffers waiting to be written (i.e. closing while IsPlaying() returns 1 would truncate the song
	OutputPause,			// returns previous pause state
	OutputSetVolume,				 // volume is 0-255
	OutputSetPan,   		// pan is -128 to 128
	OutputDrain,			// flushes buffers and restarts output at time t (in ms) 
	GetOutputTime,  		// returns played time in MS
	GetWrittenTime  		// returns time written in MS (used for synching up vis stuff)








};

CStandardOutput::~CStandardOutput()
{
}

CStandardOutput::CStandardOutput(CString dllPath, HWND hWnd) : OutputInterface(dllPath)
{
	standardOut.hDllInstance = AfxGetInstanceHandle();
	standardOut.hMainWindow = hWnd;
}

int CStandardOutput::GetVersion()   	 // module version (OUT_VER)
{
	return standardOut.version;
}

TCHAR* CStandardOutput::GetDescription()	 // description of module, with version string
{
	return standardOut.description;
}
int CStandardOutput::GetId()		   // module id. each input module gets its own. non-nullsoft modules should
{
	return standardOut.id;
}


void CStandardOutput::SethMainWindow(HWND hWnd) 	// winamp's main window (filled in by winamp)
{
	standardOut.hMainWindow = hWnd;
}
void CStandardOutput::SethDllInstance(HINSTANCE hDLL)   // DLL instance handle (filled in by winamp)
{
}

void CStandardOutput::Config(HWND hwndParent) // configuration dialog
{
	standardOut.Config(hwndParent);
}

void CStandardOutput::About(HWND hwndParent)  // about dialog
{
	standardOut.About(hwndParent);
}

void CStandardOutput::Init()	   // called when loaded
{
	standardOut.Init();
}

void CStandardOutput::Quit()	   // called when unloaded
{
	standardOut.Quit();
}

int CStandardOutput::Open(int samplerate, int numchannels, int bitspersamp, int bufferlenms, int prebufferms)
	// returns >=0 on success, <0 on failure
	// NOTENOTENOTE: bufferlenms and prebufferms are ignored in most if not all output plug-ins. 
	//    ... so don't expect the max latency returned to be what you asked for.
	// returns max latency in ms (0 for diskwriters, etc)
	// bufferlenms and prebufferms must be in ms. 0 to use defaults. 
	// prebufferms must be <= bufferlenms
{
	return standardOut.Open(samplerate, numchannels, bitspersamp, bufferlenms, prebufferms);
}

void CStandardOutput::Close() // close the ol' output device.
{
	standardOut.Close();
}

int CStandardOutput::Write(char* buf, int len)
	// 0 on success. Len == bytes to write (<= 8192 always). buf is straight audio data. 
	// 1 returns not able to write (yet). Non-blocking, always.
{
	return standardOut.Write(buf, len);
}

int CStandardOutput::CanWrite()  // returns number of bytes possible to write at a given time. 
	// Never will decrease unless you call Write (or Close, heh)
{
	return standardOut.CanWrite();
}

int CStandardOutput::IsPlaying() // non0 if output is still going or if data in buffers waiting to be
	// written (i.e. closing while IsPlaying() returns 1 would truncate the song
{
	return standardOut.IsPlaying();
}

int CStandardOutput::Pause(int pause) // returns previous pause state
{
	return standardOut.Pause(pause);
}


void CStandardOutput::SetVolume(int volume) // volume is 0-255
{
	standardOut.SetVolume(volume);
}
void CStandardOutput::SetPan(int pan) // pan is -128 to 128
{
	standardOut.SetPan(pan);
}

void CStandardOutput::Flush(int t)  // flushes buffers and restarts output at time t (in ms) 
	// (used for seeking)
{
	standardOut.Flush(t);
}

int CStandardOutput::GetOutputTime() // returns played time in MS
{
	return standardOut.GetOutputTime();
}

int CStandardOutput::GetWrittenTime() // returns time written in MS (used for synching up vis stuff)
{
	return standardOut.GetWrittenTime();
}

Out_Module* CStandardOutput::GetOut_Module()
{
	return &standardOut;
}