// FormattingDialog.cpp
//

#include "../stdafx.h"

#include "../wa_ipc.h"

#include "in_mpg123.h"

#include "HttpFile.h"
#include "ICYInfo.h"

#include "Param.h"
#include "FormattingDialog.h"
#include "PropertySheet.h"
#include "../MainHelper.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

void reflect_setting(void);
void reflect_thread_setting(void);

BOOL CALLBACK in_formatting_dialog_proc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_PAINT:
		return FALSE;
	case WM_INITDIALOG:
		{
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LTAG_PRIORITY);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LFORMATTING_FORMAT);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LFORMATTING_TITLE);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LFORMATTING_ARTIST);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LFORMATTING_ALBUM);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LFORMATTING_YEAR);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LFORMATTING_COMMENT);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LFORMATTING_GENRE);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LFORMATTING_ID3TRACK);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LFORMATTING_ID3COMPOSER);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LFORMATTING_ID3ARTIST);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LFORMATTING_COPYRIGHT);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LFORMATTING_ID3ENCODER);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LFORMATTING_FILENAME);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LFORMATTING_FILEPATH);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LFORMATTING_FILEEXTENSION);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LFORMATTING_DEFAULT);

			SetDlgItemText(hDlg, IDC_ED_TITLE, prm->m_strID3Format);

			CString buf = m_HelperIn.MyLoadString(IDS_LID3v2APEID3v1);
			SendDlgItemMessage(hDlg, IDC_COMBO_TAG_PRIORITY, CB_ADDSTRING, 0, (LPARAM)(LPCSTR)buf);
			buf = m_HelperIn.MyLoadString(IDS_LID3v2ID3v1APE);
			SendDlgItemMessage(hDlg, IDC_COMBO_TAG_PRIORITY, CB_ADDSTRING, 0, (LPARAM)(LPCSTR)buf);
			buf = m_HelperIn.MyLoadString(IDS_LAPEID3v2ID3v1);
			SendDlgItemMessage(hDlg, IDC_COMBO_TAG_PRIORITY, CB_ADDSTRING, 0, (LPARAM)(LPCSTR)buf);
			buf = m_HelperIn.MyLoadString(IDS_LAPEID3v1ID3v2);
			SendDlgItemMessage(hDlg, IDC_COMBO_TAG_PRIORITY, CB_ADDSTRING, 0, (LPARAM)(LPCSTR)buf);
			buf = m_HelperIn.MyLoadString(IDS_LID3v1ID3v2APE);
			SendDlgItemMessage(hDlg, IDC_COMBO_TAG_PRIORITY, CB_ADDSTRING, 0, (LPARAM)(LPCSTR)buf);
			buf = m_HelperIn.MyLoadString(IDS_LID3v1APEID3v2);
			SendDlgItemMessage(hDlg, IDC_COMBO_TAG_PRIORITY, CB_ADDSTRING, 0, (LPARAM)(LPCSTR)buf);

			SendDlgItemMessage(hDlg, IDC_COMBO_TAG_PRIORITY, CB_SETCURSEL, prm->m_nTagPriority, 0);
			break;
		}
	case WM_NOTIFY:
		{
			LPPSHNOTIFY lppsn = (LPPSHNOTIFY)lParam;
			switch (lppsn->hdr.code)
			{
			case PSN_APPLY :
				{
					CWnd::FromHandle(hDlg)->GetDlgItemText(IDC_ED_TITLE, prm->m_strID3Format);

					bool bFlag = false;

					if (prm->m_nTagPriority != SendDlgItemMessage(hDlg, IDC_COMBO_TAG_PRIORITY, CB_GETCURSEL, 0, 0))
					{
						prm->m_nTagPriority = SendDlgItemMessage(hDlg, IDC_COMBO_TAG_PRIORITY, CB_GETCURSEL, 0, 0);
						bFlag = true;
					}
					if (bFlag)
					{
						::reflect_thread_setting();
					}
					::reflect_setting();
					break;
				}
			case PSN_QUERYCANCEL:
				EndDialog(hDlg, LOWORD(wParam));
				break;
			}
			break;
		}
	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDOK:
		case IDCANCEL:
		default:
			return FALSE;
		}
	}

	return TRUE;
}

